; Routines d'extensions du kernel.

; Fonction sympa:
;	IsKernelPrgm ?
;	ReExportFunctions
;	Appel Rom avec depilage automatique ?
;	ExecExclusive

reloc:	movem.l	d1-d7/a1-a6,-(a7)
	moveq	#0,d7			; Relocation Mode selected
relocHd	move.w	d0,-(a7)		; Push handle
	ROM_THROW	HeapDeref	; Get address
	addq.w	#2,a7			; Fix sp
	lea	2(a0),a5		; Program Ptr
relocDo	lea	FirstRun(Pc),a6		; Load Data ref
	HW2TSR_PATCH a5,d0		; Patch if HW2 TSR
	bsr	start_relocation	; Relocation / Unrelocation
	movem.l	(a7)+,d1-d7/a1-a6	
	rts
reloc2:	movem.l	d1-d7/a1-a6,-(a7)
	moveq	#0,d7			; Relocation Mode selected
relocAn	move.l	a6,a5			; Get Program Ptr
	bra.s	relocDo			; Do relocation / unrelocation
unreloc	movem.l	d1-d7/a1-a6,-(a7)
	moveq	#1,d7			; UnRelocation Mode selected
	bra.s	relocHd			; UnRelocation of the selected handle
unreloc2 movem.l d1-d7/a1-a6,-(a7)
	moveq	#1,d7			; UnRelocation Mode selected
	bra.s	relocAn			; Unrelocation of the ptr

			
kernel::idle:	
	trap	#12				; Go to Supervisor mode to get SR
	move.w	SR,d0
	andi.w	#$0700,d0			; Get Interrupt Mask
	lsr.w	#8,d0
	move.b	IntMaskTab(Pc,d0.w),$600005	; Stop procs until an int is trigered
	and.w	#$0F00,SR
	rts

IntMaskTab	dc.b	%11111,%11110,%11100,%11000,%10000,%00000,%00000,%00000

kernel::exec:
	movem.l	d3-d7/a2-a6,-(a7)

	move.w	d0,-(a7)
	ROM_THROW	HeapDeref

	moveq	#0,d3
	move.w	(a0),d3

	cmpi.b	#$F3,1(a0,d3.l)	; is it an ASM ?
	bne.s	\Fail		; no -> bye !

	clr.w	(a7)		; Clear Copy Handle

	move.l	a0,a3
	cmp.l	#$200000,a3
	blt.s	\notarchived
		; Unarchive the prog
		addq.l	#3,d3		; Add size of 'size' and 'type' to the handle size
		move.l	d3,-(a7)
		ROM_THROW	HeapAlloc
		addq.l	#4,a7

    		move.w	d0,(a7)		; Pushes the handle of the temp block for future use
		beq.s	\Fail
		ROM_THROW	HeapDeref

		move.l a0,a1		; a5 : destination
		subq.w #1,d3
\cpy			move.b	(a3)+,(a1)+    ; copy to RAM
			dbf	d3,\cpy
\notarchived
	; Lock the handle
	ori.w	#$8000,-2(a0)		; Lock the handle if it is a nostub program
	HW2TSR_PATCH a0,d0

	; Patch it with Tios Relocation
	moveq	#0,d1
	move.w	(a0)+,d1		; Read size
	move.l	a0,a5
	pea	-1(a0,d1.l)
	pea	(a5)
	ROM_THROW	EX_patch
	addq.l	#8,a7
	
	; Call the program
	jsr	(a5)

	move.w	d0,d4
	tst.w	(a7)		; Get the saved handle
	beq.s	\end
		ROM_THROW	HeapFree
\end
	addq.w	#2,a7
	move.w	d4,d0
	movem.l	(a7)+,d3-d7/a2-a6 
	rts
\Fail   
	moveq	#-128,d4
	bra.s	\end
	
;	HANDLE:d0 kernel::Ptr2Hd(void *a0)
kernel::Ptr2Hd:	;(In: a0 Out: d0)
	movem.l	d1-d3/a1-a2,-(a7)

	; Get the address between 0 and 256 Kb
	move.l	a0,d3
	andi.l	#$00F3FFFF,d3
	
	move.l	RAM_TABLE+$11*4(Pc),a1
	move.l	(a1),a1
	addq.l	#4,a1		; Skip the first entry Opt : movea.w #RAM...+4,a1
	move.w	#2048-2,d2
	moveq	#1,d0
	moveq	#0,d1
\loop		move.l	(a1)+,a2	; Read address of handle
		cmp.l	a2,d3
		blt.s	\next		; Is Hd->addr > a0 ?
		move.w	-(a2),d1
		add.w	d1,d1
		lea	2(a2,d1.l),a2
		cmp.l	a2,d3		; If Hd->addr + Hd->size < a0 ?
		blt.s	\end
\next		addq.w	#1,d0		; Next Handle
		dbf	d2,\loop
		clr.w	d0
\end:	movem.l	(a7)+,d1-d3/a1-a2
	rts

; SYM_ENTRY:a0 kernel::Hd2Sym(HANDLE d0)
kernel::Hd2Sym:
	movem.l	d0-d3/a1-a2,-(a7)
	move.w	d0,d3
	; Parcourt de la VAT a la recherche du handle
	move.w	#2,-(a7)
	clr.l	-(a7)
	ROM_THROW SymFindFirst
	addq.l	#6,a7
\loop		cmp.w	SYM_ENTRY.hVal(a0),d3
		beq.s	\sym_found
			ROM_THROW SymFindNext
			move.l	a0,d0
			bne.s	\loop
	suba.l	a0,a0			; Impossible de trouver le handle dans la VAT
\sym_found
	movem.l	(a7)+,d0-d3/a1-a2
	rts
	
;	LIB_DESCRIPTOR:a0 kernel::LibsBegin(char name[] a0, VERSION d1.b)
kernel::LibsBegin:
	movem.l	d0-d7/a1-a6,-(a7)
	; Recherche de la librarie dans la VAT et desarchivage
	bsr	find_lib
	move.l	a0,d0
	beq.s	\end
		; Check version
		cmp.b	VERSION_OFFSET(a0),d1
		bhi.s	\error
			; Reallocation de la librarie.
			move.l	a0,a5
			bsr	kernel::relocation
			tst.w	d0
			beq.s	\end
\error				suba.l	a0,a0		; Erreur
\end	movem.l	(a7)+,d0-d7/a1-a6
	rts
	
;	kernel::LibsEnd(LIB_DESCRIPTOR a0)
kernel::LibsEnd:
	movem.l	d0-d7/a0-a6,-(a7)
	; Dereallocation et effacement
	move.l	a0,a5
	bsr	kernel::unrelocation
	movem.l	(a7)+,d0-d7/a0-a6
	rts

;	kernel::LibsCall(LIBS Descriptor, WORD function, ...)
kernel::LibsCall:
	movem.l	a0/d0-d1,-(a7)
	move.l	(4*4)(a7),a0
	move.w	(4*4+4)(a7),d0
	bsr.s	kernel::LibsPtr
	move.l	a0,d0
	beq.s	\error
		lea	\jump+2(Pc),a0
		move.l	d0,(a0)
		movem.l	(a7)+,a0/d0-d1
\jump		jmp	($0).l
\error	movem.l	(a7)+,a0/d0-d1
	rts

;	kernel::LibsPtr(LIBS Descriptor a0, WORD function d0)
kernel::LibsPtr:
	pea	(a1)
	
	; Check Signature
	cmp.l	#'68kP',4(a0)
	beq.s	\success
	cmp.l	#'68kL',4(a0)
	bne.s	\error
\success:

	move.l	a0,a1
	adda.w	$16(a0),a0	; Export table
	cmp.w	(a0)+,d0	; Out of range ?
	bhi.s	\error
	
	ext.l	d0		; Extension but d0.b only => d0.l = d0.w
	add.w	d0,d0
	move.w	0(a0,d0.w),d0	; Get offset
	lea	0(a1,d0.l),a0
	
\end	move.l	(a7)+,a1
	rts
\error	suba.l	a0,a0
	bra.s	\end


;	kernel::LibsExec(char name[], WORD function, BYTE version, ...)
kernel::LibsExec:
	movem.l	d0-d7/a0-a6,-(a7)
	; Sauve l'adresse de retour
	lea	\RetVal+2(pc),a0
	move.l	(4*15)(a7),(a0)
	; Recherche de la librarie dans la VAT et desarchivage
	move.l	(4*16)(a7),a0
	clr.l	(4*16)(a7)		; Set Error
	bsr	find_lib
	move.l	a0,d0
	beq.s	\end
	; Reallocation de la librarie.
	move.l	a0,a5
	bsr	kernel::relocation
	tst.w	d0
	bne.s	\end
	; Sauve Ptr de libs
	lea	\LibPtr+2(Pc),a1
	move.l	a5,(a1)
	; Pointeur
	move.w	(4*16+4)(a7),d0
	move.b	(4*16+4+2)(a7),d1
	bsr.s	kernel::LibsPtr
	move.l	a0,d0
	beq.s	\error
	; Appel
	lea	\jump+2(Pc),a0
	move.l	d0,(a0)			; Modification adresse appel
	movem.l	(a7)+,d0-d7/a0-a6
	lea	12(a7),a7		; Pop : Version.b, Num.w, Str.l, Ret.l
	pea	\next(pc)		; Retour
\jump	jmp	($0).l			; Modifiee par routine 
\next	subq.l	#8,a7			; Bonne position de la stack...
\RetVal	pea	(0).l			; Remets la bonne valeur de retour
	movem.l	d0-d7/a0-a6,-(a7)
	st.b	(4*16)(a7)		; Set No error
\error	; Dereallocation et effacement
\LibPtr	lea	(0).l,a5
	bsr	kernel::unrelocation
\end:	movem.l	(a7)+,d0-d7/a0-a6
	rts

;	kernel::HdKeep(HANDLE d0)
kernel::HdKeep:
	movem.l	a0/d0-d1,-(a7)
HdTable	move.l	#0,a0		; Read save table
	moveq	#7,d1
	and.w	d0,d1			; -> Bit
	lsr.w	#3,d0			; -> Offset
	bset.b	d1,0(a0,d0.w)		; Set it.
	movem.l	(a7)+,a0/d0-d1
	rts
	
;char *a0 kernel::Ptr2Symbol(void *a0)
kernel::Ptr2Symbol:
	movem.l	d0-d4/a1,-(a7)

	move.l	a0,d4		; Save Ptr
	bsr	kernel::Ptr2Hd
	tst.w	d0		; Handle found ?
	beq.s	\fail

	move.w	d0,-(a7)
	ROM_CALL HeapDeref	; Get the address of the handle
	addq.l #2,a7

	moveq	#0,d1
	move.w	(a0)+,d1	; Read size
	sub.l	a0,d4		; Get offset
	
	move.l	($4)(a0),d0	; Check 68k signature
	lsr.l	#8,d0
	cmp.l	#'68k',d0
	bne.s	\fail
	btst.b	#4,($11)(a0)	; Check if there is a symbol table
	beq.s	\fail
	lea	-6(a0,d1.l),a0		; Point to zero
\loop		; Read offset
		move.b	1(a0),d1	; Lecture offset : poids fort
		lsl.w	#8,d1
		move.b	2(a0),d1	; Lecture offset : poids faible
		cmpi.w	#$FFFF,d1	; End of symbol table (The first symbol may be skiped ?)
		beq.s	\fail
		; Next offset
		subq.l	#1,a0		; Skip current zero
\zero			tst.b	-(a0)
			bne.s	\zero
		; Fix it if the offset is < $FF
		tst.b	-(a0)		; Is it the zero of an offset ?
		beq.s	\fix
			addq.l	#1,a0	; Do not fix
\fix		cmp.w	d4,d1		; Test si SymbolOffset < Offset
		bhi.s	\loop
\found	addq.l	#3,a0			; Get the string
	bra.s	\ret
\fail	suba.l	a0,a0			; Error
\ret	movem.l	(a7)+,d0-d4/a1
	rts
	