; Warning:
;	Avant de modifier quelque chose, faites gaffe.
;	C de la haute precision.
;	La moindre difference dans le code peut s'averer fatale !

MAX_HANDLES	EQU	2048			; Nombre d'handles a sauvegarder
MAX_RAMCALL	EQU	$20			; Nombre de RAMCALLS

RELOC_MAC	MACRO
	tst.b	d7
	beq.s	\\@reloc
		neg.l	\1
\\@reloc
		ENDM

kernel::start_kernel_prgm:		; Dbut de la fonction exec
	move.l	(a7)+,a0		; Load program address
	HW2TSR_PATCH a0,d0
	movem.l	d2-d7/a2-a6,-(a7)

	; Charge le programme
	lea	-4(a0),a5		;met l'adresse du programme appel dans a5
	
	; Restaure les int
	bsr	kernel_install_int

	; Init
	tst.w	(a6)
	bne.s	already_install
		; Gere RetVal : effacement de Retval (Par defaut, il n'y en a pas)
		clr.l	RetVal-FirstRun(a6)
		
		; Sauvegarde de la table des handles
		move.l	RAM_TABLE+$11*4(Pc),a1	; a1 = Heap Table
		move.l	(a1),a1
		lea	-MAX_HANDLES/8(a7),a7	; Push Table
		move.l	a7,a0			; A0 = Save table
		move.l	a0,(HdTable+2-FirstRun)(a6)	; Save Table
		clr.b	(a0)			; Clear it
		move.w	#MAX_HANDLES-1,d2	; d2 = number of handles we save the state of
		moveq	#1,d1     		; d1 = bit mask
\loop			tst.l	(a1)+		; this handle is allocated ?
			beq.s	\noset
				or.b	d1,(a0)	;  -> set corresponding bit within the info-table
\noset			rol.b	#1,d1		; go to next bit
			bcc.s	\nonext		; next bit is within the next byte ?
				addq.l	#1,a0	;  -> go to the next byte (info-table)
				clr.b	(a0)
\nonext			dbra	d2,\loop	; loop 2000 times
		
		; ReSauve les auto-ints
		moveq	#7-1,d0
		lea	($40000+$64),a1
		lea	OldAutoInt1(Pc),a0
\loop_autoint:		move.l  (a1)+,(a0)+		; Save old handler
			dbra    d0,\loop_autoint

		; Protection ER_catch
		lea	-60(a7),a7		;60 octets pour ErrorFrame
		move.l	a7,-(a7)
		ROM_THROW ER_catch		; Protection anti-crash de Ti-Os
		addq.l	#4,a7
		tst.w	d0
		beq.s	\ok_catch		; 1 erreur est-elle arrivee ?
			; Pb ER_catch n'est plus valide !
			; Restaure les int de PreOS
			bsr	kernel_install_int
			move.w	d0,-(a7)
			ROM_THROW find_error_message
			addq.w	#2,a7
			move.l	a0,OrgStack-FirstRun(a6)
			bra.s	_quitER
		; Sauve pile
\ok_catch	move.l	a7,org_stack-FirstRun(a6)
		
		; Le gestionnaire d'erreur est au point maintenant
already_install
	addq.w	#1,(a6)

	bsr	kernel::relocation		; Relocation du prog -> a5
	tst.w	d0
	bne.s	\reloc_error
	
	movem.l	d0-d7/a0-a6,-(a7)
	moveq	#0,d0
	move.w	12(a5),d0
	beq.s	\no_run
		jsr	0(a5,d0.l)		; Execution
\no_run	movem.l	(a7)+,d0-d7/a0-a6
		
	bsr	kernel_install_int		; L'application pourrait faire mumuse avec :(
	bsr	kernel::unrelocation		; Unrelocation du prog -> a5

	; Aucune erreur
	clr.l	OrgStack-FirstRun(a6)

\reloc_error
	subq.w	#1,FirstRun-FirstRun(a6)
	bne.s	no_finish
_quit		; Restaure les int
		bsr	kernel_install_int
		; Restaure pile
		move.l	org_stack-FirstRun(a6),a7
		ROM_THROW ER_success		; On appelle ER_success // Can crash if ER_linked frame is corrupted
_quitER		lea	60(a7),a7
		
		st.b	FirstRun-FirstRun(a6)	; Pour dire aux crash handlers que l'on quitte
		bsr	clean_up		; On unrealloue tous les progs / appels exits points / liberes memoire
		bsr	reinstall_tios		; On reinstalle les ports, l'ecran et les auto-ints.
		
		; Restaure la table des handles
		move.l	RAM_TABLE+$11*4(Pc),a2	; a2 = Heap Table
		move.l	(a2),a2
		move.l	a7,a3			; A3 = save table	
		move.w	#MAX_HANDLES-1,d5	; d5 = number of handles
		clr.b	d4			; d4 = bit number = 0
		clr.w	d3			; d3 = handle number = 0
\loop			tst.l	(a2)+		; handle is allocated ?
			beq.s	\OK		; NO -> OK
			btst.b	d4,(a3)		;  -> handle was not allocated before ?
			bne.s	\OK		; was allocated before -> OK
			move.w	d3,d0
			bsr	kernel::Hd2Sym	; Then see if this handle is in VAT (it is a file or a folder)
			move.l	a0,d0		; Test if Null
			bne.s	\OK
				move.w	d3,-(a7)
				ROM_THROW	HeapFree
				addq.w	#2,a7
\OK			addq.w	#1,d3            ; increase handle number
			addq.b	#1,d4            ; increase bit number
			cmpi.b	#8,d4		; bit number == 8 ?
			bne.s	\next
				addq.l	#1,a3	;  -> go to next byte in handle-info-table
				clr.b	d4	;  -> go to first bit within this byte
\next			dbf	d5,\loop
		lea	MAX_HANDLES/8(a7),a7
		
		; Gere RET_VAL
		lea	RetVal(Pc),a0
		move.l	(a0),d0
		beq.s	\noretval
			move.l	56+4(a7),a0
			cmp.l	#$200000,a0	; L'appel vient bien du TiOs ?
			bls.s	\noretval
			cmpi.w	#$21EE,(a0)+	; movea.w -$40(a6) ? ou movea.l a3, ?
			bne.s	\norom2
				addq.l	#2,a0	; Skip -$40(a6)
\norom2			movea.w	(a0)+,a1	; Read the ret val
			move.l	d0,(a1)		; Write it
			move.l	a0,56+4(a7)	; Correction de l'adresse de retour au tios
\noretval	
		; Fin de kernel
		clr.w	(a6)
no_finish
	; Affichage des erreurs la !
	move.l	OrgStack-FirstRun(a6),-(a7)
	beq.s	\noh
		ROM_THROW ST_showHelp
\noh	addq.l	#4,a7

	movem.l (a7)+,d2-d7/a2-a6
	rts

kernel_install_int:
	; Remets les int de l'os extender (Prudence !)
	lea	newER_throw(Pc),a0	;l'adresse o est ER_throw
	move.l	a0,$40028		;$28
	lea	new1111(Pc),a0		;l'adresse o est Line1111 
	move.l	a0,$4002C		;$2C
	lea	FirstRun(Pc),a6		; Adressage relatif du code
	rts
	
; ReInstalles les traps du TiOs, ainsi que les ports.
reinstall_tios:
		ROM_THROW PortRestore
		; Demande que l'application courante redessine l'ecran
		; Test du flag du programme
		btst.b	#2,$11(a5)		; En cas de crash kernel, a5 = 0
		bne.s	reinstall_tios_vars
		lea	-60(a7),a7		; Space for window struct
		move.l	a7,a0
		clr.w	-(a7)			; No flags set !
		pea	FullScr(Pc)		; La fenetre a une taille immense :)
		pea	(a0)			; Depose la Window
		ROM_THROW WinOpen		; On creer cette fenetre
		ROM_THROW WinActivate		; On l'active
		ROM_THROW WinClose		; Et on la ferme => L'application se redessine !
		pea	mmemory(Pc)
		ROM_THROW ST_showHelp
		ROM_THROW ST_eraseHelp		; Redessine la barre des statuts
		lea	(4+4+2+60+4)(a7),a7
		; Redessine la ligne noire
blackline	lea	(LCD_MEM+30*(100-7)).w,a0
		moveq	#30-1,d0		; On deborde un peu sur 89 mais c pas grave.
\blck_line		st.b	(a0)+
			dbf	d0,\blck_line

reinstall_tios_vars:
		; Remets le crash_handler
		lea	crash_handler(Pc),a0		; Install crash handler
		moveq	#7-1,d0
		lea	($40000+$8+$4),a1
\loop_handler:		move.l  a0,(a1)+		; Install new one
			dbf	d0,\loop_handler

		; Remets les auto-ints
		moveq	#7-1,d0
		lea	($40000+$80),a1
		lea	OldAutoInt7+4(Pc),a0
\loop_autoint:		move.l	-(a0),-(a1)		; Restore Auto-Int
			dbra    d0,\loop_autoint

		; Remets l'int 6
		lea	newint6(Pc),a1
		move.l	a1,$40064+5*4
		
		; Restaure les ports
		move.w	#$4C00/8,$600010	; Remet le bon cran
hwtimer		move.b	#$B2,$600017

		; ReAutorise les auto-ints (si on est deja dans ce mode, c'est pas grave !)
		; On ne peut pas le faire avant puisqu'elles peuvent etre corrompus.
		clr.w	d0
		trap	#1

		; Remets le contraste
		moveq	#4,d0				; Get contraste
		trap    #9	
orgcontrast	move.b	#$00,(a0)
		moveq	#9,d0
		trap	#9
		jmp	(a0)


; Appelle par la routine de reloc lors d'une ereur.
; Evite le bordel du ER_catch en le faisant a la main
; In :
;	d0.w = Numero de l'erreur
;	a3 -> Nom de la lib
relocation::erreur
	move.l	OrgStack-FirstRun(a6),a7	; Restore Stack
	move.l	OrgRef-FirstRun(a6),a5		; Restore Main Program Ref
	tst.b	d7		; Si on etait en phase de relocation
	bne.s	\no_unrealloc	; on appelle l'unrelocation
		moveq	#1,d7	; Unreloc the program.
		bsr	relocation_recur	; It will return here with the same exeption !
\no_unrealloc:
	tst.w	d0			; 0
	bne.s	\memory
		lea	mmemory(pc),a0
\memory:
	subq.w	#1,d0			; 1
	bne.s	\libnotfound
		lea	mlibrairie(pc),a1
		move.l	(a3)+,(a1)+
		move.l	(a3)+,(a1)+
		lea	mpastrouve(pc),a0
\libnotfound:
	subq.w	#1,d0			; 2
	bne.s	\libnotwrong
		lea	mmauvaise(pc),a1
		move.l	(a3)+,(a1)+
		move.l	(a3)+,(a1)+
		lea	mwrong(pc),a0
\libnotwrong:
	subq.w	#1,d0			; 3
	bne.s	\romnotwrong
		lea	wrongrom(Pc),a0
\romnotwrong
	subq.w	#1,d0			; 4
	bne.s	\kernelnotwrong
		lea	wrongkernel(Pc),a0
\kernelnotwrong
	subq.w	#1,d0			; 5
	bne.s	\noparityerror
		lea	parityerror(pc),a0
\noparityerror
	move.l	a0,OrgStack-FirstRun(a6)	; Sauve l'erreur
	st.b	d0				; Une erreur est survenue
	rts					; Retour a l'appelant

kernel::unrelocation:
	moveq	#1,d7		; Mode : UnRelocation
	bra.s	start_relocation

kernel::relocation:
	moveq	#0,d7		; Mode : Relocation
start_relocation:
	lea	OrgStack-FirstRun(a6),a1
	move.l	a7,(a1)+	; Save original SP
	move.l	a5,(a1)+	; Save a5 (Program ref)
	
; In:
;	a5 -> Program
;	d7.b = 0 si Reloc
;	d7.b = 1 si UnReloc
;	d7.w += 256 si parcourt non recursif
relocation_recur:
	movem.l d0-d7/a0-a6,-(a7)

	; Lecture de la taille du fichier dans d6 pour verifier les depassements d'offset
	moveq	#0,d6
	move.w	-2(a5),d6
	
	;  Compteur de relocation
	tst.b	d7
	bne.s	\unrelloc
		ori.w	#$8000,-4(a5)		; Lock the handle (Ok, mais c plus rapide !)
		addq.b	#1,9(a5)		; Nbr de relocation
		cmp.b	#1,9(a5)
		bne 	fin_relocation	
		bra.s	\cpt_relloc
\unrelloc
		subq.b	#1,9(a5)
		bne 	fin_relocation	
\cpt_relloc

	lea	$1A(a5),a4		; a4 pointe sur la Table d'importation

	; Importation des libraries
	move.w	(a4)+,d5		; Nombre de librairies utilises dans d5
	beq.s	finish_lib		; Si aucune, passe  la suite
		move.w	d5,d0		; On calcule la table d'offset des libs
		mulu.w	#10,d0		; d3=10*d7
		lea	0(a4,d0.w),a3	; a3 = liste d'offset des librairies utilises
		exg	a4,a3		; On echange leur role
\next_lib:		move.l	a3,a0		; a0 = nom de la lib cherche
			bsr	find_lib	; Appel
			move.l	a0,d0		; a0 = addresse de la lib desarchivee
			bne.s	\impect
				moveq	#1,d0	; "Lib not found"
				bra	relocation::erreur
\impect:
			; Test de la version de la lib
			move.b	9(a3),d0	; Version demandee
			cmp.b	VERSION_OFFSET(a0),d0	; Version reelle de la lib
			bhi.s	\wrong_version
			
			; Initialiser la librairie (tout + sous-lib si besoin est)
			btst.l	#8,d7		; Test si on demande un parcourt recursif
			bne.s	\no_recur
				exg.l	a0,a5	; Relocation libs...
				bsr.s	relocation_recur
				exg.l	a0,a5
\no_recur
			move.l	a0,a1
			adda.w	$16(a1),a1	; Adresse de l'export table de la librairie dans a1
			move.w	(a1)+,d1	; Nombre de fonctions exportees dans d1
			move.w	(a4)+,d2	; Nombre de fonctions importees dans d2
\reloc_lib
				moveq	#0,d3		; Au cas o d3>$8000
				move.w	(a4)+,d3	; Numro de la fonction dans d3
				cmp.w	d1,d3
				blt.s	\good_version
\wrong_version:				moveq	#2,d0	; La fonction n'existe pas.
					bra	relocation::erreur
\good_version:			add.w	d3,d3		
				move.w	0(a1,d3.w),d3	;offset de la fonction dans d3
				move.l	a0,d4		;adresse de la lib dans d4
				add.l	d3,d4		;adresse de la fonction dans d4
				bsr	do_reloc	; Relocation de la fonction.
				dbf	d2,\reloc_lib	; Pour chaque fonction importee
			lea	10(a3),a3		;pour chercher prochaine librairie
			subq.w	#1,d5
			bne.s	\next_lib	;tant qu'il en reste, continue
finish_lib

	; Importation de la ROM
	move.w	(a4)+,d1		;y a t il des fonctions appeles ?
	beq.s	finish_rom
		move.l	($C8).w,a0	; Table des fonctions ROM
		move.w (a4)+,d1		; Nb de fonctions diffrentes utilises
\loop1			moveq	#0,d4		; Clear
			move.w	(a4)+,d4	; Numro de la fonction dans d4
			cmp.l	-4(a0),d4	; Check it
			blt.s	\valid_romcall
				moveq	#3,d0	; Error: Wrong Rom Version
				bra	relocation::erreur
\valid_romcall		lsl.w	#2,d4		; d2*4 -> d4
			move.l	0(a0,d4.w),d4	; Adresse de la fonction dans d4
			bsr	do_reloc	; Relocation de la fonction
\endloop2	dbra	d1,\loop1
finish_rom:

	;RAM relocation table
	move.w	(a4)+,d1		;Nombre de RAM_CALLS > 0 (A quoi ca sert... a rien :(
	beq.s	finish_ram
		move.w (a4)+,d1		;Nombre de RAM_CALLS DIFFERENTES !
fonctionRAM:		moveq	#0,d2
			move.w	(a4)+,d2	; Read RAM_CALL
			move.l	d2,d3		; Copie
			lsl.w	#2,d3		; d2*4 car valeurs = adresses ou longs mots
						; & Remove the word flag & the extra_ram flag
			btst	#14,d2		; Lock for EXTRA_RAM_ADDRESS
			bne.s	\extraramtable
				cmp.w	#MAX_RAMCALL*4-4,d3	; Check if valid RAM_CALL
				bls.s	\validramcall
					moveq	#4,d0	; Error: Wrong Kernel Version
					bra	relocation::erreur
\validramcall			lea	RAM_TABLE(pc),a3	;dbut de la table des valeurs dans a4
				move.l	0(a3,d3.w),d4		;valeur dans d4
				bra.s	loopRAMInit
\extraramtable:			add.w	$18(a5),d3		;offset de l'EXTRA_RAM_TABLE
				moveq	#0,d4
ExtraRamCalc			move.w	0(a5,d3.l),d4
loopRAMInit		RELOC_MAC	d4

\loopRAM:		moveq	#0,d3
			move.w	(a4)+,d3
			beq.s	\loopRAMend
				bsr	checkparity
				tst.w	d2		; Test bit 15.
				blt.s	\word
					add.l	d4,0(a5,d3.l)
					bra.s	\loopRAM
\word					add.w	d4,0(a5,d3.l)
					bra.s	\loopRAM
\loopRAMend	dbra	d1,fonctionRAM
finish_ram

	;Relocation table (les variables)
	move.l	a5,d4		; Adresse de dbut de programme dans d4
	bsr	do_reloc	; Relocation des variables

	;BSS
	move.w	$14(a5),d0		; Offset de table des BSS
	beq.s	finish_BSS
		lea	0(a5,d0.w),a4	; Address Offset BSS in a4
		
		tst.b	d7		; Test relocation ?
		bne.s	\unrelloc
			; Relocation !
			move.l	(a4)+,-(a7)	;empile taille du bloc (Et en long mot sic :(
			ROM_THROW HeapAllocHigh
			move.w	d0,$12(a5)	; Sauve l'handle
			bne.s	\ok_mem
				moveq	#0,d0
				bra	relocation::erreur
\ok_mem			move.w	d0,-(a7)	; On veut son adresse
			ROM_THROW HeapDeref
			addq.l	#6,a7		;2+4
			move.l	a0,d4		;adresse du bloc BSS dans d4
			bra.s	\brarelloc
\unrelloc		move.w	$12(a5),-(a7)	; L'handle du bloc BSS
			bne.s	\HdExist
				moveq	#0,d0
				bra	relocation::erreur
\HdExist		ROM_THROW HeapDeref
			move.l	a0,d4		; Adresse du bloc BSS dans d4
			addq.l	#4,a4		; Skip taille
			ROM_THROW HeapFree	; Libere l'handle
			clr.w	$12(a5)		; Il n'y a plus d'handle
			addq.l	#2,a7
\brarelloc
	bsr	do_reloc	; Relocation des variables BSS
finish_BSS

	; Test si dernier truc pour unrealloc
	subq.w	#1,d7			; On ne le fait que si c unrealloc recursif.
	bne.s	fin_relocation
_reloc_free:
		andi.w	#$7FFF,-4(a5)		; UnLock the handle
		move.l	a5,a0			; a0 = a5
		bsr	kernel::Ptr2Hd		; Calc Handle in d0 (2 octets en moins qu'avec HeapPtr... et on ne peut pas faire autrement si on utilise HW2TSR -ou un masque-)
		move.w	d0,d3
		beq.s	fin_relocation
			; Parcourt de la VAT a la recherche du handle
			bsr	kernel::Hd2Sym
			move.l	a0,d0
			beq.s	fin_relocation	; Impossible de trouver le handle dans la VAT
			move.l	a0,a3
			btst	#6,SYM_ENTRY.flags(a3)	; Attribut = Local ?
			beq.s	fin_relocation
				addq.l	#SYM_ENTRY.compat,a3
				move.w	(a3),4(a3)	; Recopie Handle de la sym
				clr.w	(a3)+		; Compat = 0
				bset	#1,(a3)		; Attribut = Archive
				bclr	#6,(a3)		; Attribut = Non local
				move.w	d3,-(a7)	; d3 = Handle du fichier = SYM_ENTRY.hVal(a3)
				ROM_THROW HeapFree	; Libere la copie
				addq.l	#2,a7		; A faire APRES la modif de la sym !
fin_relocation
	movem.l (a7)+,d0-d7/a0-a6
	clr.w	d0				; Ok
return	rts

reloc_free:
	movem.l d0-d7/a0-a6,-(a7)
	bra.s	_reloc_free

; In:
;	a4 -> Table d'offset
;	d4.l = Valeur a ajouter (suivant d7)
;	d7 = Relocation / Unrelocation
;	a5 -> Prg ref
;	d6 = Taille du programme
do_reloc:
	RELOC_MAC	d4
	moveq	#0,d3
\loop:
	move.w	(a4)+,d3	;offset dans d3
	beq.s	return
		bsr.s	checkparity
		add.l	d4,0(a5,d3.l)
		bra.s	\loop
	
; Test de la parite de l'offset et controle debordement programme
; Offset d3
checkparity:
	cmp.l	d6,d3		; Test depassement du programme ?
	bge.s	\error
	btst.l	#0,d3		; Test parite de l'offset
	beq.s	return
\error		moveq	#5,d0	; Erreur de Stub
		bra	relocation::erreur


; Fonction de nettoyage des ASM
; Parcourt la VAT a la recherche de prog kernel en cours de relocation.
; Appel leur point d'exit, les unrealloue (Sans appel recursif)
; et les rearchive
;
; Pb le handle des fichiers peut bouger durant la desallocation
; et la desallocation necessite un SymfindFirst. Solution: Tout deposer sur la pile
; avant de travailler dessus
clean_up:
	; Recherche des fichiers
	move.w	#2,-(a7)
	clr.l	-(a7)
	ROM_THROW SymFindFirst
\clean_loop					; Boucle de parcourt de la VAT
		bsr	IsKernelPrgm		; Test si c un programme Kernel
		tst.w	d0
		beq.s	\clean_next
			move.w	SYM_ENTRY.hVal(a0),-(a7)
			ROM_THROW HeapDeref	; Get the address
			addq.l	#2,a7
			addq.l	#2,a0		; Skip the size
			tst.b	9(a0)
			beq.s	\clean_next	; En cours de relocation ?
				pea	(a0)	; Le depose pour traitement ulterieur (Ce fichier est locke !)
\clean_next	ROM_THROW SymFindNext		; Fichier suivant : ca peut tout bloquer ! (Solution: ON+ESC)
		move.l	a0,d0
		bne.s	\clean_loop
	move.l	a7,a4				; Sauve tableau
	
	; Appel aux exit points
\loopexit	move.l	(a4)+,d0		; Get the file
		beq.s	\loopexitend
			move.l	d0,a0		; Get the address
			; Appel a l'exit point
			moveq	#0,d0
			move.w	$E(a0),d0
			beq.s	\no_exit_point
				cmpi.b	#$FF,$9(a0)	; Test si ce exit a deja foire ?
				beq.s	\no_exit_point
					st.b	$9(a0)		; Protection infini contre le reappel de exit
					movem.l	d0-d7/a0-a6,-(a7)
					jsr	0(a0,d0.l)	; Appel a exit
					movem.l	(a7)+,d0-d7/a0-a6
\no_exit_point:		bra.s	\loopexit
\loopexitend
	
	; Derealloue les programmes
	move.l	a7,a4					; Restore file tab
\loopunrelloc	move.l	(a4)+,d0			; Get the file
		beq.s	\loopunrellocend
			move.l	d0,a5			; Get the address
			; Derealocation du programme
			move.b	#1,$9(a5)			; Preparation a la dereallocation
			movem.l	d0-d7/a0-a6,-(a7)		; Preserve registre meme si...
			move.w	#256+1,d7			; Mode Unreallocation sans recursivite
			bsr	relocation_recur		; Mode Unreloc
			movem.l	(a7)+,d0-d7/a0-a6
			bra.s	\loopunrelloc
\loopunrellocend
		
	; Libere les copies archivees
\loopfree	move.l	(a7)+,d0			; Get the file
		beq.s	\loopend
			move.l	d0,a5			; Get the address
			bsr	reloc_free		; Libere la copie si elle existe
			bra.s	\loopfree
\loopend
	; Fin
	addq.w	#2,a7
	rts

; Determine si c'est un programme Kernel
; In:
;	a0.l -> Sym Entry
; Out:
;	d0 = 0 si c pas un prog kernel
IsKernelPrgm:
	movem.l	d1-d2/a0-a1,-(a7)

	move.w	SYM_ENTRY.hVal(a0),-(a7)
	ROM_THROW HeapDeref
	addq.l	#2,a7

	clr.w	d0
	moveq	#0,d1
	move.w	(a0)+,d1
	cmp.b	#$F3,-1(a0,d1.l)
	bne.s	\echec
		move.l	4(a0),d1
		lsr.l	#8,d1
		cmpi.l	#'68k',d1
		bne.s	\echec
	st.b	d0
\echec	movem.l	(a7)+,d1-d2/a0-a1
	rts
	

; Recherche des libraries.
; Les copies si besoin est
; In:
;	a0 ->  Lib Name
; Out:
;	a0 -> Lib desarchivee (premire ligne de code)
find_lib:
	movem.l	d0-d5/a1-a3,-(a7)
	
	move.l	a0,a2
	move.w	#2,-(a7)		; Parcourt de l'ensemble de la VAT
	clr.l	-(a7)
	ROM_THROW SymFindFirst
	addq.l	#6,a7
\loop		move.l	a0,a3
		bsr.s	IsKernelPrgm	; Kernel ?
		tst.w	d0
		beq.s	\no_kernel	; No kernel => no lib
			pea	(a0)
			pea	(a2)
			ROM_THROW SymCmp
			addq.l	#8,a7	
			tst.w	d0	; Is the good file ?
			bne.s	\no_kernel
				move.w	SYM_ENTRY.hVal(a3),-(a7)
				ROM_THROW HeapDeref
				addq.l	#2,a7
				btst.b	#3,($11+2)(a0)		; Test flag read only
				bne.s	\find			; Si ro, on ne la desarchive pas !
				btst	#1,SYM_ENTRY.flags(a3)
				beq.s	\find		;pas archiv : c'est bon
					; Archive => Creation copie
					move.l	a0,a2		; Sauve l'adresse de la lib
				
					moveq	#3,d5		; Taille + 3 (Pas + 2 ?) pour la place de la taille
					add.w	(a0),d5		; + Taille file 
					move.l	d5,-(a7)
					ROM_THROW HeapAllocHigh
					addq.l	#4,a7

					tst.w	d0
					beq.s	\no_kernel

					move.w	SYM_ENTRY.hVal(a3),SYM_ENTRY.compat(a3)
					move.w	d0,SYM_ENTRY.hVal(a3)

					bset	#6,SYM_ENTRY.flags(a3)	; Attribut = local
					bclr	#1,SYM_ENTRY.flags(a3)	; Attribut = desarchive

					move.w	d0,-(a7)
					ROM_THROW HeapDeref
					addq.l	#2,a7

					; Recopie du fichier
					move.l	a0,a1
\copy_loop:					move.b	(a2)+,(a1)+
						subq.w	#1,d5		; Plus court d'un octet
						bne.s	\copy_loop	; car subq + dbra = 6 octets !
\find				addq.l	#2,a0	; Skip the size
				HW2TSR_PATCH a0,d0
				bra.s	\end
\no_kernel	ROM_THROW SymFindNext
		move.l	a0,d0
		bne.s	\loop
\end	movem.l	(a7)+,d0-d5/a1-a3
	rts

RAM_TABLE	ds.l	MAX_RAMCALL	;il y a 21 valeurs  stocker
Calc		dc.b	0	; CALCULATOR
Hw		dc.b	0	; HW_VERSION
org_stack	dc.l	0	; Du kernel
OrgStack	dc.l	0	; De la relocation
OrgRef		dc.l	0	; Program Ref
FirstRun	dc.w	0	; Nombre de lancement
RetVal		dc.l	0	; Valeur de retour de l'estack
FullScr		dc.w	0,0,239,127
mpastrouve	dc.b "Library not found:"
mlibrairie	ds.b 9		;8 lettres et un 0
mwrong		dc.b "New version needed:"
mmauvaise	ds.b 9
mmemory		dc.b "Out of memory",0
errortext	dc.b "Crash intercepted",0
wrongrom	dc.b "New Rom needed",0
wrongkernel	dc.b "New Kernel needed",0
parityerror	dc.b "Illegal stub",0
	EVEN
	
	
;----------------------------------------------------------------------------
; do_reloc(): parse compressed relocation table
;
; Input:
;  a0 = base address of module being relocated
;  a2 = pointer to relocation table
;  d1 = number to add to each address
;----------------------------------------------------------------------------

;reloc_word:
;	lsl.w	#7,d0
;	move.b	(a2)+,d0
;	lsl.w	#2,d0
;;	lsr.w	#1,d0
;	add.w	d0,a6			; add delta to address
;	lea	$7F*2(a6),a6		; add rest of delta
;	cmp.w	#$7FFE,d0
;	beq	reloc_loop
;	add.l	d1,(a6)+
;	bra	reloc_loop
;reloc_byte:
;	lea	-2(a6,d0.w),a6		; add delta to address
;	add.l	d1,(a6)+
;	bra	reloc_loop

;do_reloc_rts:
;	move.l	(sp)+,a6
;	rts

;do_unreloc:
;	neg.l	d1
;do_reloc:
;	move.l	a6,-(sp)
;	lea	24(a0),a6
;reloc_loop:
;	clr.w	d0
;	move.b	(a2)+,d0
;	beq	do_reloc_rts
;	lsl.b	#1,d0
;	bcc	reloc_byte
;	bmi	reloc_word
;reloc_nibbles:
;	move.w	d0,d2
;	lsr.b	#5,d0
;	and.w	#$1E,d2
;	add.w	d2,a6			; add delta to address
;	add.l	d1,(a6)+
;reloc_nibble_loop:
;	move.b	(a2)+,d2
;	move.w	d2,d3
;	lsr.b	#4,d2			; get high nibble
;	add.w	d2,a6			; add delta to address \ times
;	add.w	d2,a6			; add delta to address /  two
;	add.l	d1,(a6)+
;	and.w	#$F,d3			; get low nibble
;	add.w	d3,a6			; add delta to address \ times
;	add.w	d3,a6			; add delta to address /  two
;	add.l	d1,(a6)+
;	dbf.w	d0,reloc_nibble_loop
;	bra	reloc_loop
